import VueCompiler from './compiler-vue'

export default (md, Vue) => {
  const defaultRenderer = md.renderer.rules.fence.bind(md.renderer.rules);
  md.renderer.rules.fence = (tokens, idx, opts, env, self) => {
    const token = tokens[idx]
    const code = `${token.content.trim()}`
    if (/^vue/.test(token.info)) {
      // const id = token.info.replace('vue', '').trim()
      const id = 'compiler-vue' + parseInt(Math.random() * 10000)
      // if (!id) return '<div class="vue-block-error">请输入唯一标识，格式为```vue xxx</div>'
      if (!code) return `<div class="vue-block-error">请输入有效的Vue代码</div>`
      const currentBlock = {}
      currentBlock.vueCompiler = new VueCompiler(Vue)
      const error = currentBlock.vueCompiler.splitCode(code)
      currentBlock.workable = !error
      Vue.prototype.$vueBlocks[id] = currentBlock
      return error ? `<div class="vue-block-error">${error}</div>` : `<div id="${id}"></div>`
    }
    return defaultRenderer(tokens, idx, opts, env, self)
  }
}
